import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { BatchGetBuildBatchesInput, BatchGetBuildBatchesOutput } from "../models/models_0";
export interface BatchGetBuildBatchesCommandInput extends BatchGetBuildBatchesInput {
}
export interface BatchGetBuildBatchesCommandOutput extends BatchGetBuildBatchesOutput, __MetadataBearer {
}

export declare class BatchGetBuildBatchesCommand extends $Command<BatchGetBuildBatchesCommandInput, BatchGetBuildBatchesCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: BatchGetBuildBatchesCommandInput;
    constructor(input: BatchGetBuildBatchesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchGetBuildBatchesCommandInput, BatchGetBuildBatchesCommandOutput>;
    private serialize;
    private deserialize;
}
