import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { BatchGetProjectsInput, BatchGetProjectsOutput } from "../models/models_0";
export interface BatchGetProjectsCommandInput extends BatchGetProjectsInput {
}
export interface BatchGetProjectsCommandOutput extends BatchGetProjectsOutput, __MetadataBearer {
}

export declare class BatchGetProjectsCommand extends $Command<BatchGetProjectsCommandInput, BatchGetProjectsCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: BatchGetProjectsCommandInput;
    constructor(input: BatchGetProjectsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchGetProjectsCommandInput, BatchGetProjectsCommandOutput>;
    private serialize;
    private deserialize;
}
