import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { CreateReportGroupInput, CreateReportGroupOutput } from "../models/models_0";
export interface CreateReportGroupCommandInput extends CreateReportGroupInput {
}
export interface CreateReportGroupCommandOutput extends CreateReportGroupOutput, __MetadataBearer {
}

export declare class CreateReportGroupCommand extends $Command<CreateReportGroupCommandInput, CreateReportGroupCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: CreateReportGroupCommandInput;
    constructor(input: CreateReportGroupCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateReportGroupCommandInput, CreateReportGroupCommandOutput>;
    private serialize;
    private deserialize;
}
