import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { DeleteReportInput, DeleteReportOutput } from "../models/models_0";
export interface DeleteReportCommandInput extends DeleteReportInput {
}
export interface DeleteReportCommandOutput extends DeleteReportOutput, __MetadataBearer {
}

export declare class DeleteReportCommand extends $Command<DeleteReportCommandInput, DeleteReportCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: DeleteReportCommandInput;
    constructor(input: DeleteReportCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteReportCommandInput, DeleteReportCommandOutput>;
    private serialize;
    private deserialize;
}
