import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { DeleteSourceCredentialsInput, DeleteSourceCredentialsOutput } from "../models/models_0";
export interface DeleteSourceCredentialsCommandInput extends DeleteSourceCredentialsInput {
}
export interface DeleteSourceCredentialsCommandOutput extends DeleteSourceCredentialsOutput, __MetadataBearer {
}

export declare class DeleteSourceCredentialsCommand extends $Command<DeleteSourceCredentialsCommandInput, DeleteSourceCredentialsCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: DeleteSourceCredentialsCommandInput;
    constructor(input: DeleteSourceCredentialsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteSourceCredentialsCommandInput, DeleteSourceCredentialsCommandOutput>;
    private serialize;
    private deserialize;
}
