import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { DescribeTestCasesInput, DescribeTestCasesOutput } from "../models/models_0";
export interface DescribeTestCasesCommandInput extends DescribeTestCasesInput {
}
export interface DescribeTestCasesCommandOutput extends DescribeTestCasesOutput, __MetadataBearer {
}

export declare class DescribeTestCasesCommand extends $Command<DescribeTestCasesCommandInput, DescribeTestCasesCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: DescribeTestCasesCommandInput;
    constructor(input: DescribeTestCasesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeTestCasesCommandInput, DescribeTestCasesCommandOutput>;
    private serialize;
    private deserialize;
}
