import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { ListBuildBatchesInput, ListBuildBatchesOutput } from "../models/models_0";
export interface ListBuildBatchesCommandInput extends ListBuildBatchesInput {
}
export interface ListBuildBatchesCommandOutput extends ListBuildBatchesOutput, __MetadataBearer {
}

export declare class ListBuildBatchesCommand extends $Command<ListBuildBatchesCommandInput, ListBuildBatchesCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: ListBuildBatchesCommandInput;
    constructor(input: ListBuildBatchesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListBuildBatchesCommandInput, ListBuildBatchesCommandOutput>;
    private serialize;
    private deserialize;
}
