import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { ListBuildBatchesForProjectInput, ListBuildBatchesForProjectOutput } from "../models/models_0";
export interface ListBuildBatchesForProjectCommandInput extends ListBuildBatchesForProjectInput {
}
export interface ListBuildBatchesForProjectCommandOutput extends ListBuildBatchesForProjectOutput, __MetadataBearer {
}

export declare class ListBuildBatchesForProjectCommand extends $Command<ListBuildBatchesForProjectCommandInput, ListBuildBatchesForProjectCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: ListBuildBatchesForProjectCommandInput;
    constructor(input: ListBuildBatchesForProjectCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListBuildBatchesForProjectCommandInput, ListBuildBatchesForProjectCommandOutput>;
    private serialize;
    private deserialize;
}
