import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { ListBuildsInput, ListBuildsOutput } from "../models/models_0";
export interface ListBuildsCommandInput extends ListBuildsInput {
}
export interface ListBuildsCommandOutput extends ListBuildsOutput, __MetadataBearer {
}

export declare class ListBuildsCommand extends $Command<ListBuildsCommandInput, ListBuildsCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: ListBuildsCommandInput;
    constructor(input: ListBuildsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListBuildsCommandInput, ListBuildsCommandOutput>;
    private serialize;
    private deserialize;
}
