import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { ListBuildsForProjectInput, ListBuildsForProjectOutput } from "../models/models_0";
export interface ListBuildsForProjectCommandInput extends ListBuildsForProjectInput {
}
export interface ListBuildsForProjectCommandOutput extends ListBuildsForProjectOutput, __MetadataBearer {
}

export declare class ListBuildsForProjectCommand extends $Command<ListBuildsForProjectCommandInput, ListBuildsForProjectCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: ListBuildsForProjectCommandInput;
    constructor(input: ListBuildsForProjectCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListBuildsForProjectCommandInput, ListBuildsForProjectCommandOutput>;
    private serialize;
    private deserialize;
}
