import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { ListCuratedEnvironmentImagesInput, ListCuratedEnvironmentImagesOutput } from "../models/models_0";
export interface ListCuratedEnvironmentImagesCommandInput extends ListCuratedEnvironmentImagesInput {
}
export interface ListCuratedEnvironmentImagesCommandOutput extends ListCuratedEnvironmentImagesOutput, __MetadataBearer {
}

export declare class ListCuratedEnvironmentImagesCommand extends $Command<ListCuratedEnvironmentImagesCommandInput, ListCuratedEnvironmentImagesCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: ListCuratedEnvironmentImagesCommandInput;
    constructor(input: ListCuratedEnvironmentImagesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListCuratedEnvironmentImagesCommandInput, ListCuratedEnvironmentImagesCommandOutput>;
    private serialize;
    private deserialize;
}
