import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { ListReportGroupsInput, ListReportGroupsOutput } from "../models/models_0";
export interface ListReportGroupsCommandInput extends ListReportGroupsInput {
}
export interface ListReportGroupsCommandOutput extends ListReportGroupsOutput, __MetadataBearer {
}

export declare class ListReportGroupsCommand extends $Command<ListReportGroupsCommandInput, ListReportGroupsCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: ListReportGroupsCommandInput;
    constructor(input: ListReportGroupsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListReportGroupsCommandInput, ListReportGroupsCommandOutput>;
    private serialize;
    private deserialize;
}
