import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { StartBuildBatchInput, StartBuildBatchOutput } from "../models/models_0";
export interface StartBuildBatchCommandInput extends StartBuildBatchInput {
}
export interface StartBuildBatchCommandOutput extends StartBuildBatchOutput, __MetadataBearer {
}

export declare class StartBuildBatchCommand extends $Command<StartBuildBatchCommandInput, StartBuildBatchCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: StartBuildBatchCommandInput;
    constructor(input: StartBuildBatchCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<StartBuildBatchCommandInput, StartBuildBatchCommandOutput>;
    private serialize;
    private deserialize;
}
