import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodeBuildClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodeBuildClient";
import { StopBuildBatchInput, StopBuildBatchOutput } from "../models/models_0";
export interface StopBuildBatchCommandInput extends StopBuildBatchInput {
}
export interface StopBuildBatchCommandOutput extends StopBuildBatchOutput, __MetadataBearer {
}

export declare class StopBuildBatchCommand extends $Command<StopBuildBatchCommandInput, StopBuildBatchCommandOutput, CodeBuildClientResolvedConfig> {
    readonly input: StopBuildBatchCommandInput;
    constructor(input: StopBuildBatchCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodeBuildClientResolvedConfig, options?: __HttpHandlerOptions): Handler<StopBuildBatchCommandInput, StopBuildBatchCommandOutput>;
    private serialize;
    private deserialize;
}
