import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodePipelineClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodePipelineClient";
import { CreateCustomActionTypeInput, CreateCustomActionTypeOutput } from "../models/models_0";
export interface CreateCustomActionTypeCommandInput extends CreateCustomActionTypeInput {
}
export interface CreateCustomActionTypeCommandOutput extends CreateCustomActionTypeOutput, __MetadataBearer {
}

export declare class CreateCustomActionTypeCommand extends $Command<CreateCustomActionTypeCommandInput, CreateCustomActionTypeCommandOutput, CodePipelineClientResolvedConfig> {
    readonly input: CreateCustomActionTypeCommandInput;
    constructor(input: CreateCustomActionTypeCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodePipelineClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateCustomActionTypeCommandInput, CreateCustomActionTypeCommandOutput>;
    private serialize;
    private deserialize;
}
