import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodePipelineClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodePipelineClient";
import { GetActionTypeInput, GetActionTypeOutput } from "../models/models_0";
export interface GetActionTypeCommandInput extends GetActionTypeInput {
}
export interface GetActionTypeCommandOutput extends GetActionTypeOutput, __MetadataBearer {
}

export declare class GetActionTypeCommand extends $Command<GetActionTypeCommandInput, GetActionTypeCommandOutput, CodePipelineClientResolvedConfig> {
    readonly input: GetActionTypeCommandInput;
    constructor(input: GetActionTypeCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodePipelineClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetActionTypeCommandInput, GetActionTypeCommandOutput>;
    private serialize;
    private deserialize;
}
