import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodePipelineClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodePipelineClient";
import { GetPipelineStateInput, GetPipelineStateOutput } from "../models/models_0";
export interface GetPipelineStateCommandInput extends GetPipelineStateInput {
}
export interface GetPipelineStateCommandOutput extends GetPipelineStateOutput, __MetadataBearer {
}

export declare class GetPipelineStateCommand extends $Command<GetPipelineStateCommandInput, GetPipelineStateCommandOutput, CodePipelineClientResolvedConfig> {
    readonly input: GetPipelineStateCommandInput;
    constructor(input: GetPipelineStateCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodePipelineClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetPipelineStateCommandInput, GetPipelineStateCommandOutput>;
    private serialize;
    private deserialize;
}
