import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodePipelineClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodePipelineClient";
import { ListActionExecutionsInput, ListActionExecutionsOutput } from "../models/models_0";
export interface ListActionExecutionsCommandInput extends ListActionExecutionsInput {
}
export interface ListActionExecutionsCommandOutput extends ListActionExecutionsOutput, __MetadataBearer {
}

export declare class ListActionExecutionsCommand extends $Command<ListActionExecutionsCommandInput, ListActionExecutionsCommandOutput, CodePipelineClientResolvedConfig> {
    readonly input: ListActionExecutionsCommandInput;
    constructor(input: ListActionExecutionsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodePipelineClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListActionExecutionsCommandInput, ListActionExecutionsCommandOutput>;
    private serialize;
    private deserialize;
}
