import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CodePipelineClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CodePipelineClient";
import { ListActionTypesInput, ListActionTypesOutput } from "../models/models_0";
export interface ListActionTypesCommandInput extends ListActionTypesInput {
}
export interface ListActionTypesCommandOutput extends ListActionTypesOutput, __MetadataBearer {
}

export declare class ListActionTypesCommand extends $Command<ListActionTypesCommandInput, ListActionTypesCommandOutput, CodePipelineClientResolvedConfig> {
    readonly input: ListActionTypesCommandInput;
    constructor(input: ListActionTypesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CodePipelineClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListActionTypesCommandInput, ListActionTypesCommandOutput>;
    private serialize;
    private deserialize;
}
