import { Message, MessageHeaders } from "@aws-sdk/types";
import { Decoder, Encoder } from "@aws-sdk/types";

export declare class EventStreamMarshaller {
    private readonly headerMarshaller;
    constructor(toUtf8: Encoder, fromUtf8: Decoder);
    
    marshall({ headers: rawHeaders, body }: Message): Uint8Array;
    
    unmarshall(message: ArrayBufferView): Message;
    
    formatHeaders(rawHeaders: MessageHeaders): Uint8Array;
}
